#
# Anbox - The Android in a Box runtime environment
# Copyright 2019 Canonical Ltd.  All rights reserved.
#

from charmhelpers.core.hookenv import status_set
from charms.reactive import Endpoint


class RestProvides(Endpoint):
    def set_registry_information(self, certificate, fingerprint, ip, port):
        for relation in self.relations:
            relation.to_publish['certificate'] = certificate
            relation.to_publish['fingerprint'] = fingerprint
            relation.to_publish['ip'] = ip
            relation.to_publish['port'] = port

    def ams_clients(self):
        publisher_certificates = []
        for relation in self.relations:
            for unit in relation.units:
                if unit.received['certificate'] is None:
                    continue

                # If there is a relation mismatch, we set an error status
                # ex: juju add-relation aar:client ams:publisher
                mode = unit.received['mode']
                if mode not in self.endpoint_name:
                    status_set('blocked', 'Invalid relation {} to {}'.format(
                        'arr-' + mode,
                        self.endpoint_name)
                    )
                    return
                publisher_certificates.append(unit.received)
        return publisher_certificates
