#
# Anbox - The Android in a Box runtime environment
# Copyright 2019 Canonical Ltd.  All rights reserved.
#
from charms.reactive import Endpoint


class RestRequires(Endpoint):
    def registry(self):
        if len(self.relations) is 0:
            return None
        if len(self.relations[0].units) is 0:
            return None

        return self.relations[0].units[0].received

    def remove_ams_client(self):
        if len(self.relations) is not 1:
            return
        del self.relations[0].to_publish['mode']
        del self.relations[0].to_publish['certificate']

    def new_ams_client(self, certificate, mode):
        """
        Register a new AMS publisher
        """
        if len(self.relations) is not 1:
            return

        # The mode is defined by the relation, but we still set it here
        # so the AAR charm can figure out of an incorrect relation was
        # established
        self.relations[0].to_publish['mode'] = mode
        self.relations[0].to_publish['certificate'] = certificate
